//  ** Revision History **
//  15-Mar-1993 (AH) release 1.0.0.000

//****************************************************************************
//                    Copyright (C) 1992-1995 EuroSource AB
//
// FILE:         hline.c  (part of EuroCtrl project)
//   
// PURPOSE:      Make a Ownerdrawn Groupbox
//   
// COMMENTS:     
//   
// HISTORY:      920525AH Prehistory
//   
//****************************************************************************                    

#define  NOCOMM
#include <windows.h>
#include <vbapi.h>
#include <string.h>
#include "eshline.h"


#include "version.h"
#define  CTL_DATA       // To declare static data in hline.h
#include "hline.h"
#include "vb1.h"		// Support for Visual Basic 1.0
#include "vb2.h"		// Support for Visual Basic 2.0
#include "helpid.h"

//---------------------------------------------------------------------------
// Global Variables
//---------------------------------------------------------------------------
extern HANDLE hmodDLL;
extern WORD ipropDialog;
extern HCTL hctlDialog;     


//---------------------------------------------------------------------------
// Local Prototypes
//---------------------------------------------------------------------------
VOID NEAR DrawHline(HCTL hctl, HWND hWnd, HDC hDC);
VOID NEAR RecalcAreaHline(HCTL hctl, HWND hWnd);

//**************************************************************************
//                        Copyright (C) 1992-1995 EuroSource AB
//
//      FUNCTION:   LONG FAR PASCAL _export HlineCtlProc(HCTL hctl, HWND hwnd, USHORT msg, USHORT wp, LONG lp)       
//
//      PURPOSE:    Hline Control Procedure     
//
//      COMMENTS:        
//
//      HISTORY:    920815AH Prehistory     
//
//**************************************************************************

LONG FAR PASCAL _export HlineCtlProc(HCTL hctl, HWND hWnd, USHORT msg, USHORT wp, LONG lp)
{
    LONG        lResult; 
    PHLINE      phline;

    // Message pre-processing
    switch (msg) { 
	case WM_CREATE:
	    phline = HLINEDEREF(hctl);
	    phline->LineWidth = 1;
	    phline->LineStyle=LINESTYLESOLID;
	    phline->Line3DStyle=LINESTYLE3DNORMAL;

#ifndef RUNTIMEVERSION        	       
	    // set the property text for the About dialog
	    SetAboutText(hctl, IPROP_HLINE_ABOUT);            
#endif        
	    
	    VBSetControlProperty(hctl, IPROP_HLINE_BACKCOLOR, 
				       HLINE_BACKGROUND_DEFAULT);
	break;

#ifndef RUNTIMEVERSION    	
    
	case VBM_INITPROPPOPUP:
	switch (wp) {
	    case IPROP_HLINE_ABOUT:
		hctlDialog  = hctl;
		ipropDialog = wp;
		return (LONG)HwndInitAboutPopup();
	}
	break; 
		   
	case WM_RBUTTONDBLCLK: 
	    if (VBGetMode() == MODE_DESIGN) {
		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, eshline);
		return OK;
	    }
	    else
		break;
#endif	
    
	case WM_ERASEBKGND:
	    // Don't bother with erasing the background
	    return TRUE;

	case WM_SIZE:
	    RecalcAreaHline(hctl, hWnd); 
	    break;

    case VBM_GETDEFSIZE:
            return MAKELONG(HLINE_DEFAULTWIDTH,HLINE_DEFAULTHEIGHT);	    
        
	case WM_PAINT:
	    if (wp)
		DrawHline(hctl, hWnd, (HDC)(wp));
	    else {
		PAINTSTRUCT     ps;

		BeginPaint(hWnd, &ps);
		DrawHline(hctl, hWnd, ps.hdc);
		EndPaint(hWnd, &ps);
	    }
	    break;
	    
	case VBM_SETPROPERTY:
	    switch (wp) {
		case IPROP_HLINE_LINEWIDTH:
		case IPROP_HLINE_LINESTYLE:
		case IPROP_HLINE_LINE3DSTYLE:
		    RecalcAreaHline(hctl, hWnd);
		    InvalidateRect(hWnd, NULL, TRUE);
		    return(0L);
		    
	    }
	    break;

#ifndef RUNTIMEVERSION    
	case VBM_HELP:
	    switch (LOBYTE(wp))
		{
			case VBHELP_PROP:
		    	// High byte identifies which property.
		    	// Keyword is: "<property>"
		    	switch (HIBYTE(wp))
				{
					case IPROP_HLINE_ABOUT:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_about);
			    		return OK;

					case IPROP_HLINE_LINEWIDTH:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_linewidth);
			    		return 0L;                                                        
                    
                    case IPROP_HLINE_LINESTYLE:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_style);
			    		return 0L; 
                    
                	case IPROP_HLINE_LINE3DSTYLE:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_style3d);
			    		return 0L; 
            	
				}
				break;

		case VBHELP_CTL:
		    // High byte is unused.
		    // Keyword is: "<classname>"
		    WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, eshline);;
		    return 0L;
	}
	break;                                 	

#endif                  
        
    }

    // Default processing:
    lResult = VBDefControlProc(hctl, hWnd, msg, wp, lp);

    // Message post-processing:
    switch (msg) {
	case WM_DESTROY:
	    break;
    }

    return lResult;
}


//**************************************************************************
//                        Copyright (C) 1992-1995 EuroSource AB
//
//      FUNCTION:   VOID NEAR DrawHline(HCTL hctl, HWND hWnd, HDC hDC)       
//
//      PURPOSE:    Draw the Hline     
//
//      COMMENTS:        
//
//      HISTORY:    920815AH Prehistory     
//
//**************************************************************************

VOID NEAR DrawHline(HCTL hctl, HWND hWnd, HDC hDC)
{
    PHLINE  phline = HLINEDEREF(hctl);
    RECT        rectClient;
    HBRUSH      hbr;
    HPEN        hPenOld, hPenLight, hPenDark; 
					    
    hbr = (HBRUSH)SendMessage(GetParent(hWnd), WM_CTLCOLOR, hDC, MAKELONG(hWnd, 0));
    // create pens                      
    hPenDark = CreatePen(HLINEDEREF(hctl)->LineStyle,HLINEDEREF(hctl)->LineWidth, GetTextColor(hDC));
    hPenLight = CreatePen(HLINEDEREF(hctl)->LineStyle,1/*HLINEDEREF(hctl)->LineWidth*/, WHITE);
	GetClientRect(hWnd, &rectClient);

    SetBkMode(hDC, TRANSPARENT);        
    // fill in background
	FillRect(hDC, &rectClient, hbr);
    // draw line  
    hPenOld = SelectObject(hDC, hPenDark);
    MoveTo(hDC, 0, (rectClient.bottom/2));
    LineTo(hDC, rectClient.right, (rectClient.bottom/2));
    switch(HLINEDEREF(hctl)->Line3DStyle) {
	case    LINESTYLE3DNORMAL:
	    break;
	case    LINESTYLE3DCARVED:                               
	    if (HLINEDEREF(hctl)->LineWidth == 1) {
		SelectObject(hDC, hPenLight);
		MoveTo(hDC, 0, (rectClient.bottom/2)+1);
		LineTo(hDC, rectClient.right, (rectClient.bottom/2)+1);
	    }
	    break;
	case    LINESTYLE3DRAISED:      
	    if (HLINEDEREF(hctl)->LineWidth == 1) {
		SelectObject(hDC, hPenLight);
		MoveTo(hDC, 0, (rectClient.bottom/2)-1);
		LineTo(hDC, rectClient.right, (rectClient.bottom/2)-1);
	    }
	    break;        
    }    
    
	
    // put anything to normal again
	SelectObject(hDC, hPenOld);
	DeleteObject(hPenLight);
	DeleteObject(hPenDark);
}


//**************************************************************************
//                        Copyright (C) 1992-1995 EuroSource AB
//
//      FUNCTION:   VOID NEAR RecalcAreaHline(HCTL hctl, HWND hWnd);      
//
//      PURPOSE:    Use the hWnd's client size to determine the bounding 
//                  rectangle for the hlinepicture and associated stuff.     
//
//      COMMENTS:        
//
//      HISTORY:    920815AH Prehistory     
//
//**************************************************************************


VOID NEAR RecalcAreaHline(HCTL hctl, HWND hWnd)
{
    PHLINE  phline = HLINEDEREF(hctl);
	
}
