//****************************************************************************
//                    Copyright (C) 1992-1995 EuroSource AB
//
// FILE:         hline.h
//   
// PURPOSE:      Header file for HLINE subclass EuroCtrl project
//   
// COMMENTS:     
//   
// HISTORY:      920525AH Prehistory
//   
//****************************************************************************                    



#define HLINE_BACKGROUND_DEFAULT    GREY

// Default Width & Height
#define	HLINE_DEFAULTHEIGHT	2
#define HLINE_DEFAULTWIDTH	90

//---------------------------------------------------------------------------
// HLINE control data and structs
//---------------------------------------------------------------------------
typedef struct tagHLINE
{                     
    HSZ		hszabout;
    ENUM	LineStyle;		// Style of lines
    ENUM	Line3DStyle;	// 3D Style of lines
	SHORT	LineWidth;		// width of lines
} HLINE;

typedef HLINE FAR * PHLINE;

#define HLINEDEREF(hctl)     ((PHLINE)VBDerefControl(hctl))


//---------------------------------------------------------------------------
// Control Procedure
//---------------------------------------------------------------------------
LONG FAR PASCAL _export HlineCtlProc(HCTL, HWND, USHORT, USHORT, LONG);


#ifndef RC_INVOKED
//---------------------------------------------------------------------------
// Property list
//---------------------------------------------------------------------------
// Define the consecutive indicies for the properties
//---------------------------------------------------------------------------
#define IPROP_HLINE_NAME            0
#define IPROP_HLINE_INDEX           1
#define IPROP_HLINE_PARENT          2
#define IPROP_HLINE_BACKCOLOR       3
#define IPROP_HLINE_LEFT            4
#define IPROP_HLINE_TOP             5
#define IPROP_HLINE_WIDTH           6
#define IPROP_HLINE_HEIGHT          7
#define IPROP_HLINE_ENABLED         8
#define IPROP_HLINE_VISIBLE         9
#define IPROP_HLINE_MOUSEPOINTER    10
#define IPROP_HLINE_LINE3DSTYLE		11
#define IPROP_HLINE_FORECOLOR       12 
#define IPROP_HLINE_ABOUT			13
#define IPROP_HLINE_LINESTYLE		14
#define IPROP_HLINE_LINEWIDTH		15
#define IPROP_HLINE_HWND			16

#ifdef CTL_DATA                       

PROPINFO Property_Hline_About =
{
    "About...",
    DT_HSZ | PF_fGetData | PF_fSetData | PF_fEditable,
    OFFSETIN(HLINE, hszabout)
}; 

PROPINFO propinfoHlineLine3DStyle =
{
    "Style3D",
    DT_ENUM | PF_fGetData | PF_fSetMsg | PF_fSetData | PF_fSaveData,
    OFFSETIN(HLINE,Line3DStyle), 0,
    0,
    "0 - No 3D effect.\0"
    "1 - Carved.\0"
    "2 - Raised.\0",
    LINESTYLE3DRAISED
};    

PROPINFO propinfoHlineLineStyle =
{
    "Style",
    DT_ENUM | PF_fGetData | PF_fSetMsg | PF_fSetData | PF_fSaveData,
    OFFSETIN(HLINE,LineStyle), 0,
    0,
    "0 - Solid Line.\0"
    "1 - Dash.\0"
    "2 - Dot.\0"
    "3 - Dash Dot.\0"
    "4 - Dash Dot Dot.\0",
    LINESTYLEDASHDOTDOT
};
             
PROPINFO propinfoHlineLineWidth =
{
    "LineWidth",
    DT_SHORT | PF_fGetData | PF_fSetMsg | PF_fSetData | PF_fSaveData,
    OFFSETIN(HLINE,LineWidth), 0
}; 

PROPINFO propinfoHlinehWnd =
{
    "hWnd",
    DT_SHORT | PF_fGetMsg | PF_fNoShow | PF_fNoRuntimeW,
    0, 0
};

PPROPINFO proplistHline[] =
{
    PPROPINFO_STD_CTLNAME,
    PPROPINFO_STD_INDEX,
    PPROPINFO_STD_PARENT,
    PPROPINFO_STD_BACKCOLOR,
    PPROPINFO_STD_LEFT,
    PPROPINFO_STD_TOP,
    PPROPINFO_STD_WIDTH,
    PPROPINFO_STD_HEIGHT,
    PPROPINFO_STD_ENABLED,
    PPROPINFO_STD_VISIBLE,
    PPROPINFO_STD_MOUSEPOINTER,
    &propinfoHlineLine3DStyle,
    PPROPINFO_STD_FORECOLOR,
    &Property_Hline_About,            
    &propinfoHlineLineStyle,
    &propinfoHlineLineWidth,
    &propinfoHlinehWnd,
    NULL
};
#endif  // CTL_DATA


//---------------------------------------------------------------------------
// Event list
//---------------------------------------------------------------------------
// Define the consecutive indicies for the events
//---------------------------------------------------------------------------
#define EVENT_HLINE_DRAGDROP    0
#define EVENT_HLINE_DRAGOVER    1

#ifdef CTL_DATA
PEVENTINFO eventlistHline[] =
{
    PEVENTINFO_STD_DRAGDROP,
    PEVENTINFO_STD_DRAGOVER,
    NULL
};
#endif  // CTL_DATA


//---------------------------------------------------------------------------
// Model struct
//---------------------------------------------------------------------------
// Define the control model (using the event and property structures).
//---------------------------------------------------------------------------
#ifdef CTL_DATA
MODEL modelHline =
{
    VB_VERSION,                 // VB version being used
    MODEL_fDesInteract | MODEL_fFocusOk | MODEL_fChildrenOk,          // MODEL flags
    (PCTLPROC)HlineCtlProc,     // Control procedure
    CS_VREDRAW | CS_HREDRAW,    // Class style
    NULL,                 		// Default Window style
    sizeof(HLINE),              // cbCtlExtra for HLINE structure
    IDBMP_HLINE,                // Palette bitmap ID
    "EsHLine",		       		// Default control name
    "EsHline",		       		// Visual Basic class name
    NULL,                   	// Parent class name
    proplistHline,              // Properties list
    eventlistHline,             // Events list
	IPROP_HLINE_LINEWIDTH,		// default property in code window
	EVENT_HLINE_DRAGDROP,		// default event in code window
	IPROP_HLINE_LINEWIDTH		// standard property
};
#endif  // CTL_DATA

LPMODEL modellistHline[] =
    {
    &modelHline,
    NULL
    };

MODELINFO modelinfoHline =
    {
    VB_VERSION, 			// VB version being used
    modellistHline			// MODEL list
    };

#endif  // RC_INVOKED
